#ifndef _CONTOURWIDGET_H_
#define _CONTOURWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"
#include "maskgradientwidget.h"
#include "seuillagewidget.h"

class ContourWidget : public ToolWidget
{
	Q_OBJECT
public:
	ContourWidget( const Image& image );
	~ContourWidget();

	virtual void init();

private slots:
	void convolution( Gradient::GradientMaskType mask );
	void seuillageHysteresis( unsigned char seuil1, unsigned char seuil2 );
	void seuillageGlobal( unsigned char seuil );
	void seuillageLocal( int size );
	void refine();
	void link();

	void currentTabChanged( int );
	
private:
	Gradient* m_gradient;
	Gradient::GradientMaskType m_maskType;
	unsigned char m_seuil1, m_seuil2, m_seuil;
	int m_size;
	int m_type;
	
	MaskGradientWidget *m_mask_gradient_widget;
	SeuillageWidget *m_seuillage_widget;
	QWidget *m_refine_widget, *m_link_widget;
};

#endif
