#include "seuillagewidget.h"

SeuillageWidget::SeuillageWidget()
{
	m_seuillage_type_cb = new QComboBox();
	m_seuillage_type_cb->addItem( tr( "Hysteresis" ) );
	m_seuillage_type_cb->addItem( tr( "Global" ) );
	m_seuillage_type_cb->addItem( tr( "Local" ) );
	connect( m_seuillage_type_cb, SIGNAL( currentIndexChanged( int ) ), this, SLOT( change( int ) ) );
	
	
	m_seuil1_slider = new QSlider( );
	m_seuil1_slider->setRange( 0, 255 );
	m_seuil1_slider->setValue( 20 );
	m_seuil1_slider->setOrientation( Qt::Horizontal );
	connect( m_seuil1_slider, SIGNAL( valueChanged( int ) ), this, SLOT( change( int ) ) );
	m_seuil2_slider = new QSlider( );
	m_seuil2_slider->setRange( 0, 255 );
	m_seuil2_slider->setValue( 100 );
	m_seuil2_slider->setOrientation( Qt::Horizontal );
	connect( m_seuil2_slider, SIGNAL( valueChanged( int ) ), this, SLOT( change( int ) ) );
	
	m_seuil1_lcd = new QLCDNumber( 3 );
	m_seuil2_lcd = new QLCDNumber( 3 );
	m_seuil1_lcd->display( m_seuil1_slider->value() ) ;
	m_seuil2_lcd->display( m_seuil2_slider->value() ) ;
	
	m_seuil_global_slider = new QSlider( );
	m_seuil_global_slider->setRange( 0, 255 );
	m_seuil_global_slider->setValue( 40 );
	m_seuil_global_slider->setOrientation( Qt::Horizontal );
	m_seuil_global_slider->hide();
	connect( m_seuil_global_slider, SIGNAL( valueChanged( int ) ), this, SLOT( change( int ) ) );
	m_seuil_global_lcd = new QLCDNumber( 3 );
	m_seuil_global_lcd->display( m_seuil_global_slider->value() ) ;
	
	m_size_SB = new QSpinBox();
	m_size_SB->setRange( 1, 50 );
	connect( m_size_SB, SIGNAL( valueChanged( int ) ), this, SLOT( change( int ) ) );
	m_size_label = new QLabel( tr( "Taille de la fenetre : " ) );
	
	m_seuil1_layout = new QHBoxLayout();
	m_seuil1_layout->addWidget( m_seuil1_slider );
	m_seuil1_layout->addWidget( m_seuil1_lcd );
	m_seuil2_layout = new QHBoxLayout();
	m_seuil2_layout->addWidget( m_seuil2_slider );
	m_seuil2_layout->addWidget( m_seuil2_lcd );
	m_seuil_global_layout = new QHBoxLayout();
	m_seuil_global_layout->addWidget( m_seuil_global_slider );
	m_seuil_global_layout->addWidget( m_seuil_global_lcd );
	m_size_layout = new QHBoxLayout();
	m_size_layout->addWidget( m_size_label );
	m_size_layout->addWidget( m_size_SB );
	
	
	m_layout = new QVBoxLayout();
	m_layout->addWidget( m_seuillage_type_cb );
	m_layout->addLayout( m_seuil1_layout );
	m_layout->addLayout( m_seuil2_layout );
	m_layout->addLayout( m_seuil_global_layout );
	m_layout->addLayout( m_size_layout );
	
	setLayout( m_layout );
}

SeuillageWidget::~SeuillageWidget()
{
}

void SeuillageWidget::activate()
{
	if( m_seuillage_type_cb->currentIndex() == 0 )
	{
		m_seuil1_slider->show();
		m_seuil1_lcd->show();
		m_seuil2_slider->show();
		m_seuil2_lcd->show();
		m_seuil_global_slider->hide();
		m_seuil_global_lcd->hide();
		m_size_SB->hide();
		m_size_label->hide();
		
		m_seuil1_lcd->display( m_seuil1_slider->value() ) ;
		m_seuil2_lcd->display( m_seuil2_slider->value() ) ;
		emit seuilHysteresisChanged( (unsigned char)m_seuil1_slider->value(), (unsigned char)m_seuil2_slider->value() );
	}
	else if(  m_seuillage_type_cb->currentIndex() == 1 )
	{
		m_seuil1_slider->hide();
		m_seuil1_lcd->hide();
		m_seuil2_slider->hide();
		m_seuil2_lcd->hide();
		m_seuil_global_slider->show();
		m_seuil_global_lcd->show();
		m_size_SB->hide();
		m_size_label->hide();
		
		m_seuil_global_lcd->display( m_seuil_global_slider->value() ) ;
		emit seuilGlobalChanged( (unsigned char)m_seuil_global_slider->value() );
	}
	else
	{
		m_seuil1_slider->hide();
		m_seuil1_lcd->hide();
		m_seuil2_slider->hide();
		m_seuil2_lcd->hide();
		m_seuil_global_slider->hide();
		m_seuil_global_lcd->hide();
		m_size_SB->show();
		m_size_label->show();
		
		emit seuilLocalChanged( m_size_SB->value() );
	}
}
void SeuillageWidget::change( int )
{
	activate();
}
