#ifndef _SEUILLAGEWIDGET_H_
#define _SEUILLAGEWIDGET_H_

#include "../paramwidget.h"

#include <ImageUtils.h>

class SeuillageWidget : public ParamWidget
{
	Q_OBJECT
public:
	SeuillageWidget();
	~SeuillageWidget();
	void activate();

signals:
	void seuilHysteresisChanged( unsigned char seuil1, unsigned char seuil2 );
	void seuilGlobalChanged( unsigned char seuil );
	void seuilLocalChanged( int size );

private slots:	
	void change( int index );
	
private:
	
	/* Interface */
	QComboBox* m_seuillage_type_cb;
	QSlider* m_seuil1_slider, *m_seuil2_slider;
	QLCDNumber *m_seuil1_lcd, *m_seuil2_lcd;
	QSlider* m_seuil_global_slider;
	QLCDNumber *m_seuil_global_lcd;
	QSpinBox* m_size_SB;
	QLabel* m_size_label;
	
	
	QHBoxLayout *m_seuil1_layout, *m_seuil2_layout, *m_seuil_global_layout, *m_size_layout;
	QVBoxLayout *m_layout;
};

#endif
