#ifndef _FILTERWIDGET_H_
#define _FILTERWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"
#include "maskwidget.h"
#include "morphowidget.h"
#include "nagaowidget.h"

class FilterWidget : public ToolWidget
{
	Q_OBJECT
public:
	FilterWidget( const Image& image );
	~FilterWidget();

	virtual void init();

private slots:
	void convolution( int* mask );
	void morpho( MorphoType type, int size );
	void nagao();

	void currentTabChanged( int );
	
private:
	MaskWidget *m_mask_widget;
	MorphoWidget *m_morpho_widget;
	NagaoWidget *m_nagao_widget;
};

#endif
