#include "maskwidget.h"

MaskWidget::MaskWidget()
{
	m_masks_list = new QComboBox( );
	connect( m_masks_list, SIGNAL( currentIndexChanged( int ) ), this, SLOT( change( int ) ) );
	
	m_masks_list->addItem( "Sobel" );
	m_masks.push_back( Mask::Sobel[0] );
	m_masks_list->addItem( "Kirsh" );
	m_masks.push_back( Mask::Kirsh[0] );
	m_masks_list->addItem( "Prewitt1" );
	m_masks.push_back( Mask::Prewitt1[0] );
	m_masks_list->addItem( "Prewitt2" );
	m_masks.push_back( Mask::Prewitt2[0] );
	
	
	
	m_layout = new QHBoxLayout();
	m_layout->addWidget( m_masks_list );
	
	setLayout( m_layout );
}

MaskWidget::~MaskWidget()
{
}

void MaskWidget::activate()
{
	emit maskChanged( m_masks[m_masks_list->currentIndex()] );
}
void MaskWidget::change( int index )
{
	emit maskChanged( m_masks[index] );
}
