#include "morphowidget.h"

MorphoWidget::MorphoWidget( unsigned int max)
{
	m_CB_list = new QComboBox( );
	m_CB_list->addItem( tr( "Minimum" ) );
	m_CB_list->addItem( tr( "Maximum" ) );
	m_CB_list->addItem( tr( "Median" ) );
	
	m_SB_size = new QSpinBox();
	m_SB_size->setRange( 1, max );
	
	connect( m_CB_list, SIGNAL( currentIndexChanged( int ) ), this, SLOT( changeType( int ) ) );
	connect( m_SB_size, SIGNAL( valueChanged( int ) ), this, SLOT( changeSize( int ) ) );
	
	m_label = new QLabel( tr( "Taille de la fenetre : ") );
	
	m_layout = new QGridLayout();
	m_layout->addWidget( m_CB_list, 1, 0 );
	m_layout->addWidget( m_label, 0, 1 );
	m_layout->addWidget( m_SB_size, 1, 1 );
	
	setLayout( m_layout );
}

MorphoWidget::~MorphoWidget()
{
}

void MorphoWidget::activate()
{
	emit changed( (MorphoType) m_CB_list->currentIndex(),  m_SB_size->value() );
}

void MorphoWidget::changeType( int index )
{
	emit changed( (MorphoType)index, m_SB_size->value() );
}
void MorphoWidget::changeSize( int size )
{
	emit changed( (MorphoType) m_CB_list->currentIndex(), size );
}
