#ifndef _MORPHOWWIDGET_H_
#define _MORPHOWWIDGET_H_

#include "../paramwidget.h"

#include <ImageUtils.h>

enum MorphoType
{
	Minimum = 0,
	Maximum,
	Median
};

class MorphoWidget : public ParamWidget
{
	Q_OBJECT
public:
	MorphoWidget( unsigned int max );
	~MorphoWidget();
	void activate();
	
signals:
	void changed( MorphoType type, int size );
	
private slots:
	void changeType( int index );
	void changeSize( int size );
	
private:
	
	/* Interface */
	QLabel* m_label;

	QComboBox* m_CB_list;
	QSpinBox* m_SB_size;
	
	QGridLayout *m_layout;
};

#endif
