#ifndef _FOURIERWIDGET_H_
#define _FOURIERWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"

class FourierWidget : public ToolWidget
{
	Q_OBJECT
public:
	FourierWidget( const Image& image );
	~FourierWidget();

	virtual void init();
	virtual int exec();

private slots:
	void updatePreview();
	void idealFilter( int radius );
	void gaussianFilter( int sigma );
	void showModule();

	void currentTabChanged( int );

private:
	FourierMT* m_fourier;

	QLabel *m_ideal_filter_label, *m_gaussian_filter_label;
	QSlider *m_ideal_filter_slider, *m_gaussian_filter_slider;
	QLCDNumber *m_ideal_filter_lcd, *m_gaussian_filter_lcd;
	QWidget *m_ideal_filter_widget, *m_gaussian_filter_widget, *m_module_widget;
	QHBoxLayout *m_ideal_filter_layout, *m_gaussian_filter_layout;
	
};

#endif
