#ifndef _HOUGHWIDGET_H_
#define _HOUGHWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"

class HoughWidget : public ToolWidget
{
	Q_OBJECT
public:
	HoughWidget( const Image& image );
	~HoughWidget();

	virtual void init();
	virtual int exec();

private slots:
	void circle( int );
	void line( int );
	
	void currentTabChanged( int );

private:
	Hough* m_hough;

	QLabel			*m_line_label	, *m_circle_label;
	QSlider			*m_line_slider	, *m_circle_slider;
	QLCDNumber		*m_line_lcd		, *m_circle_lcd;
	QLabel							  *m_circle_tolerance_label;
	QSlider							  *m_circle_tolerance_slider;
	QLCDNumber						  *m_circle_tolerance_lcd;
	QWidget			*m_line_widget	, *m_circle_widget;
	QGridLayout		*m_line_layout	, *m_circle_layout;
	
};

#endif
