#include "kmeanswidget.h"

KMeansWidget::KMeansWidget( const Image& image )
	:	ToolWidget( new QWidget(), image )
{
	m_type_CB = new QComboBox();
	m_type_CB->addItem( tr( "Couleur & Distance" ) );
	m_type_CB->addItem( tr( "Ligne" ) );
	connect( m_type_CB, SIGNAL( currentIndexChanged( int ) ), this, SLOT( indexChanged( int ) ) );

	m_type_label = new QLabel( tr( "Type de distance :" ) );

	m_slider = new QSlider( );
	m_slider->setRange( 0, 255 );
	m_slider->setValue( 127 );
	m_slider->setOrientation( Qt::Horizontal );
	connect( m_slider, SIGNAL( valueChanged( int ) ), this, SLOT( deltaChanged( int ) ) );

	m_lcd = new QLCDNumber( 3 );
	m_lcd->display( m_slider->value() ) ;

	m_group_number_SB = new QSpinBox();
	m_group_number_SB->setRange( 1, 50 );
	m_group_number_SB->setValue( 10 );
	connect( m_group_number_SB, SIGNAL( valueChanged( int ) ), this, SLOT( paramChanged( int ) ) );	
	m_step_number_SB = new QSpinBox();
	m_step_number_SB->setRange( 1, 10 );
	connect( m_step_number_SB, SIGNAL( valueChanged( int ) ), this, SLOT( paramChanged( int ) ) );	
	
		
		

	m_type_layout = new QHBoxLayout();
	m_type_layout->addWidget( m_type_label );
	m_type_layout->addWidget( m_type_CB );

	m_slide_layout = new QHBoxLayout();
	m_slide_layout->addWidget( m_slider );
	m_slide_layout->addWidget( m_lcd );

	m_param_layout = new QHBoxLayout();
	m_param_layout->addWidget( m_group_number_SB );
	m_param_layout->addWidget( m_step_number_SB );

	m_widget_layout = new QVBoxLayout();
	m_widget_layout->addLayout( m_type_layout );
	m_widget_layout->addLayout( m_param_layout );
	m_widget_layout->addLayout( m_slide_layout );

	m_widget->setLayout( m_widget_layout );
}
KMeansWidget::~KMeansWidget()
{
}

void KMeansWidget::init()
{
	kmeans();
}

void KMeansWidget::indexChanged( int )
{
	kmeans();
}
void KMeansWidget::paramChanged( int )
{
	kmeans();
}
void KMeansWidget::deltaChanged( int )
{
	m_lcd->display( m_slider->value() ) ;
	kmeans();
}

void KMeansWidget::kmeans()
{
	start();
	previewImage( kMeans( m_image, m_group_number_SB->value(), m_step_number_SB->value(), m_slider->value() / 255.0f , (DistType)m_type_CB->currentIndex() ) );
	stop();
}

