#ifndef _KMEANSWIDGET_H_
#define _KMEANSWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"

class KMeansWidget : public ToolWidget
{
	Q_OBJECT
public:
	KMeansWidget( const Image& image );
	~KMeansWidget();

	virtual void init();

private slots:
	void indexChanged( int );
	void paramChanged( int );
	void deltaChanged( int );

	void kmeans();
	
private:
	QLabel *m_type_label;
	QSlider *m_slider;
	QLCDNumber *m_lcd;
	QComboBox* m_type_CB;
	QSpinBox* m_group_number_SB, *m_step_number_SB;

	QVBoxLayout* m_widget_layout;
	QHBoxLayout* m_type_layout, *m_slide_layout, *m_param_layout;
	
};

#endif
