#ifndef _HISTOWIDGET_H_
#define _HISTOWIDGET_H_

#include "../paramwidget.h"

#include <ImageUtils.h>
#include <algorithm>

#include <cmath>
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

class HistoWidget : public ParamWidget
{
	Q_OBJECT
public:
	HistoWidget();
	~HistoWidget();

	void activate();

	void init();
	void setParams( int luminosity, int contrast );
	Histo histo() const { return m_histo; }

signals:
	void changed();
	
private:
	Image m_image;
	Histo m_histo;

	unsigned int m_marge;
	int m_lastXChanged;
	
	void lineHisto( int x0, int y0, int x1, int y1 );

protected:
	virtual void paintEvent( QPaintEvent* );
	virtual void mouseMoveEvent ( QMouseEvent* );
	virtual void mousePressEvent ( QMouseEvent* );
	virtual void mouseReleaseEvent ( QMouseEvent* );

};

#endif //_HISTOWIDGET_H_
