#ifndef _SPECIFWIDGET_H_
#define _SPECIFWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "../toolwidget.h"
#include "histowidget.h"

class SpecifWidget : public ToolWidget
{
	Q_OBJECT
public:
	SpecifWidget( const Image& image );
	~SpecifWidget();

	virtual void init();

private slots:
	void histoChanged();

	void stateLocalChanged( int state );
	void valueLocalChanged( int value );

	void luminosity( int );
	void contrast( int );

private:
	HistoWidget* m_histo_widget;

	QCheckBox* m_local_CB;
	QSpinBox* m_local_size_SB;
	
	QSlider *m_lum_slider, *m_contrast_slider;
	QLCDNumber *m_lum_lcd, *m_contrast_lcd;
	QLabel *m_lum_label, *m_contrast_label;

	QGridLayout* m_sliders_layout;
	QHBoxLayout* m_local_layout;
	QVBoxLayout* m_right_layout;
	QHBoxLayout* m_widget_layout;
	
};

#endif
