#include "tramagewidget.h"

TramageWidget::TramageWidget( const Image& image )
	:	ToolWidget( new QWidget(), image )
{
	m_matrix_type_CB = new QComboBox();
	m_matrix_type_CB->addItem( tr( "Floyd & Steinberg" ) );
	m_matrix_type_CB->addItem( tr( "Jarvis, Judis & Ninke" ) );
	m_matrix_type_CB->addItem( tr( "Stucki" ) );
	connect( m_matrix_type_CB, SIGNAL( currentIndexChanged( int ) ), this, SLOT( indexChanged( int ) ) );

	m_clamp_CB = new QCheckBox( tr( "Clamper la diffusion d'erreur" ) );
	connect( m_clamp_CB, SIGNAL( stateChanged(int) ), this, SLOT( clampChanged(int) ) );
	
	m_type_label = new QLabel( tr( "Type de matrice :" ) );

	m_h_layout = new QHBoxLayout();
	m_h_layout->addWidget( m_type_label );
	m_h_layout->addWidget( m_matrix_type_CB );

	m_widget_layout = new QVBoxLayout();
	m_widget_layout->addLayout( m_h_layout );
	m_widget_layout->addWidget( m_clamp_CB );

	m_widget->setLayout( m_widget_layout );
}
TramageWidget::~TramageWidget()
{
}

void TramageWidget::init()
{
	tramage();
}

void TramageWidget::indexChanged( int )
{
	tramage();
}
void TramageWidget::clampChanged( int )
{
	tramage();
}

void TramageWidget::tramage()
{
	start();
	Image im( m_image.GetWidth(), m_image.GetHeight(), 1 );
	halfToning( &im, &m_image, (MatrixType)m_matrix_type_CB->currentIndex(), m_clamp_CB->checkState() == Qt::Checked );
	previewImage( im );
	stop();
}
