#ifndef _PREVIEWWIDGET_H_
#define _PREVIEWWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageLib.h>

#include "../imageviewer.h"

class PreviewWidget : public QWidget
{
	Q_OBJECT
public:
	PreviewWidget( const Image& image );
	~PreviewWidget();

	void setImage( const Image& image );
	const Image& image() const;
	void setImagePreview( const Image& image );
	void updateImagePreview( const Image& image );
	const Image& imagePreview() const;

public slots:
	void updateApScale( double scaleFactor );
	void updateApPosition( int x, int y );
	void updateAvScale( double scaleFactor );
	void updateAvPosition( int x, int y );

private:
	Image m_av_image;
	Image m_ap_image;

	/* Interface */
	QLabel *m_av_label, *m_ap_label;
	ImageViewer* m_av_imageviewer, *m_ap_imageviewer;

	QGridLayout *m_layout;
	
	void update();
};

#endif
