#ifndef _TOOLWIDGET_H_
#define _TOOLWIDGET_H_

#include <QtGui>
#include <QtCore>

#include <ImageUtils.h>

#include "previewwidget.h"

class ToolWidget : public QDialog
{
	Q_OBJECT
public:
	ToolWidget( QWidget* widget, const Image& image, bool auto_apply = false );
	~ToolWidget();

	virtual void init();

signals:
	void applyImage( const Image& );
	void updateImage( const Image& );

protected slots:
	void apply();
	void cancel();
	void finish( int result );

	void start();
	void stop();

	void previewImage( const Image& );
	void applyAutoChanged( int state );
	
protected:
	QWidget* m_widget;
	Image m_image;
	QTime m_time;

	QGroupBox *m_preview_GB, *m_param_GB;
	PreviewWidget *m_preview_widget;
	QCheckBox *m_cb_auto_apply;
	QPushButton *m_bt_apply, *m_bt_cancel;
	QLabel *m_time_label;

	QHBoxLayout *m_preview_layout, *m_param_layout;
	QHBoxLayout *m_buttons_layout;
	QVBoxLayout *m_layout;

	virtual void closeEvent ( QCloseEvent * e );
};

#endif
