#ifndef _IMAGELABEL_H_
#define _IMAGELABEL_H_

#include <QtGui>
#include <QtCore>

#include <ImageLib.h>

class ImageLabel : public QWidget
{
	Q_OBJECT
public:
	ImageLabel();
	~ImageLabel();

	const double scaleFactor() const { return m_scaleFactor; }
	const Image& image() const { return m_image; }
	void setImage( const Image& _image, double scaleFactor );
	
	void retranslate();
	
public slots:
	void updateImage( const Image& _image );
	void updateScale( double scaleFactor );

signals:
	void updated( double scaleFactor, double scale, int x, int y );

private:
	Image m_image;
	QPixmap m_pixmap;
	double m_scaleFactor;

	void update();

protected:
	void paintEvent( QPaintEvent *event );
	void wheelEvent( QWheelEvent *event );

};

#endif
