#pragma once

// Gestion des erreurs
enum ERROR_ID
{
	ERROR_MEMORY,
	ERROR_UNABLE_OPEN_FILE,
	ERROR_UNABLE_CREATE_FILE,
	ERROR_UNABLE_SAVE_FILE,
	ERROR_WRONG_TYPE,
	ERROR_UNKNOWN_TYPE,
	ERROR_WRONG_DIMENSIONS,
	ERROR_WRONG_DEPTH,
	ERROR_WRONG_CHAN_NUMBER,
	ERROR_CORRUPTED_FILE
};


void PrintErrorMessage( const char *message );
void PrintErrorMessage( ERROR_ID, const char *filename = 0, const char *type = 0 );


// Gestion des fichiers
class FileBuffer
{
public:
	FileBuffer( const char *filename = 0 );
	FileBuffer( const FileBuffer & );
	FileBuffer( unsigned char *data, long length );
	~FileBuffer( void );

	bool IsValid( void ) { return !!m_data; }
	
	bool ReadFile ( const char *filename );
	bool WriteFile( const char *filename );

	void Clear( void );

	unsigned char *m_data;
	long           m_length;
};
