#include "fastmaximum.h"

namespace Filtre
{

Image fast_maximum( const Image& image, unsigned int size )
{
	unsigned int chan_number = image.GetChanNumber();
	unsigned char* ptr_im;
	unsigned char* ptr_im2;
	unsigned int k;
	int i, j, in, jn, iI, jI;
	
	unsigned int** h = new unsigned int*[chan_number];
	for( k = 0 ; k < chan_number ; ++k )	
	{
		h[k] = new unsigned int[ 256 ];
	}

	Image image_result( image.GetWidth(), image.GetHeight(), chan_number );

	for( i = 0 ; i < (int)image.GetHeight() ; ++i )
	{
		for( k = 0 ; k < chan_number ; ++k )
		{
			memset( h[k], 0, 256 * sizeof( unsigned int ) );
		}

		// Premiere case de la ligne
		for( in = 0 , iI = i - (int)size ; in < (int)(2*size + 1) ; in++, iI++ )
		{
			for( jn = 0 , jI = 0 ; jn < (int)size ; jn++, jI++ )
			{
				if( iI >= 0 && iI < (int)image.GetHeight() )
				{
					ptr_im = image.GetPixel( jI, iI );
					for( k = 0 ; k < chan_number ; ++k )
					{
						h[k][ptr_im[k]]++;
					}
				}
			}
		}

		// Parcours ligne
		for( j = 0 ; j < (int)image.GetWidth() ; ++j )
		{
			for( iI = i - (int)size ; iI <= i + (int)size ; iI++ )
			{
				if( iI >= 0 && iI < (int)image.GetHeight() )
				{
					if( j-(int)size >= 0 )
					{
						ptr_im = image.GetPixel( j-(int)size, iI );
						for( k = 0 ; k < chan_number ; ++k )
						{
							h[k][ptr_im[k]]--;
						}
					}
					if( j+(int)size < (int)image.GetWidth() )
					{
						ptr_im = image.GetPixel( j+(int)size, iI );
						for( k = 0 ; k < chan_number ; ++k )
						{
							h[k][ptr_im[k]]++;
						}
					}
				}
			}
			
			ptr_im2 = image_result.GetPixel( j, i );

			for( k = 0 ; k < chan_number ; ++k )
			{
				unsigned char a = 255;
				while( h[k][a] == 0 )
					a--;
				ptr_im2[k] = a;
			}

		}
	}

	for( k = 0 ; k < chan_number ; ++k )	
	{
		delete[] h[k];
	}
	delete[] h;
	
	return image_result;
}

}
