#include "median.h"

#include <stdio.h>
#include <stdlib.h>

namespace Filtre
{

static int compare ( void const *a, void const *b )
{
   return *(unsigned char*)a - *(unsigned char*)b;
}

Image median( const Image& _image, unsigned int _size )
{
	unsigned int nbChannels = _image.GetChanNumber();
	
	unsigned char* ptr_im;
	unsigned char* ptr_im2;
	unsigned int position;
	unsigned int k;
	unsigned int i, j, in, jn, iI, jI;
	
	unsigned char** tab = new unsigned char*[nbChannels];
	for( k = 0 ; k < nbChannels ; ++k )
	{
		tab[k] = new unsigned char[(_size*2+1)*(_size*2+1)];
	}
	
	Image image_result( _image.GetWidth(), _image.GetHeight(), nbChannels );
	
	for( i = _size ; i < _image.GetHeight() - _size ; ++i )
	{
		for( j = _size ; j < _image.GetWidth() - _size ; ++j )
		{
			position = 0;
			for( in = 0 , iI = i - _size ; in < 2*_size + 1 ; in++, iI++ )
			{
				for( jn = 0 , jI = j - _size ; jn < 2*_size + 1 ; jn++, jI++ )
				{
					ptr_im = _image.GetPixel( jI, iI );
					for( k = 0 ; k < nbChannels ; ++k )
					{
						tab[k][position] = ptr_im[k];
					}
					position++;
				}
			}
			
			ptr_im2 = image_result.GetPixel( j, i );
						
			for( k = 0 ; k < nbChannels ; ++k )
			{
				qsort( tab[k], position, sizeof( unsigned char ), compare );
				ptr_im2[k] = tab[k][ position/2 ];
			}
		}
	}
	
	for( k = 0 ; k < nbChannels ; ++k )
	{
		delete[] tab[k];
	}
	delete[] tab;
	
	return image_result;
}

}
