#include "convolution.h"

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

namespace Filtre
{

Image convolution( const Image& _image, int* _mask, unsigned int _size )
{
	unsigned char* ptr_im;
	unsigned char* ptr_im2;
	unsigned int k;
	unsigned int i, j, in, jn, iI, jI;
	
	float *r = new float[ _image.GetWidth()* _image.GetHeight() * _image.GetChanNumber() ];
	float* min = new float[ _image.GetChanNumber() ];
	float* max = new float[ _image.GetChanNumber() ];
	
	for( k = 0 ; k < _image.GetChanNumber() ; ++k )
	{
		min[k] = 10000;
		max[k] = -10000;
	}
	
	Image image_result( _image.GetWidth(), _image.GetHeight(), _image.GetChanNumber() );
	
	for( i = _size ; i < _image.GetHeight() - _size ; ++i )
	{
		for( j = _size ; j < _image.GetWidth() - _size ; ++j )
		{
			for( k = 0 ; k < _image.GetChanNumber() ; ++k ) r[i * _image.GetWidth() * _image.GetChanNumber() + j * _image.GetChanNumber() + k] = 0;
			for( in = 0 , iI = i - _size ; in < 2*_size + 1 ; in++, iI++ )
			{
				for( jn = 0 , jI = j - _size ; jn < 2*_size + 1 ; jn++, jI++ )
				{
					ptr_im = _image.GetPixel( jI, iI );
					for( k = 0 ; k < _image.GetChanNumber() ; ++k )
						r[i * _image.GetWidth() * _image.GetChanNumber() + j * _image.GetChanNumber() +  k] += ptr_im[k] * _mask[in * (2*_size + 1) + jn] ;
				}
			}
			
			for( k = 0 ; k < _image.GetChanNumber() ; ++k )
			{
				int index = i * _image.GetWidth() * _image.GetChanNumber() + j * _image.GetChanNumber() +  k;
				if( r[index] < min[k] ) min[k] = r[index];
				if( r[index] > max[k] ) max[k] = r[index];
			} 
			
			
		}
	}
	for( i = _size ; i < _image.GetHeight() - _size ; ++i )
	{
		for( j = _size ; j < _image.GetWidth() - _size ; ++j )
		{
			ptr_im2 = image_result.GetPixel( j, i );
			for( k = 0 ; k < _image.GetChanNumber() ; ++k )
			{
				int index = i * _image.GetWidth() * _image.GetChanNumber() + j * _image.GetChanNumber() +  k;
				
				r[index] = 255.0f * ((r[index]-min[k]) / (max[k] - min[k]));
				
				if( r[index] > 255.0 ) r[index] = 255.0;
				if( r[index] < 0.0 ) r[index] = 0.0;
				
				
				ptr_im2[k] = (unsigned char)r[index];
			}
		}
	}
	
	
	delete[] max;
	delete[] min;
	delete[] r;
	return image_result;
}

}
