#include "nagao.h"

namespace Filtre
{

Image nagao( const Image& _image )
{
	Image image_retour( _image );
	
	int n = 2;
	unsigned int moyenne[9]     = {0,0,0,0,0,0,0,0,0};
	unsigned int variance[9]    = {0,0,0,0,0,0,0,0,0};
	unsigned int masques[9][25] = {{1,0,0,0,0,
	                        1,1,0,0,0,
	                        1,1,1,0,0,
	                        1,1,0,0,0,
	                        1,0,0,0,0},
	                       {1,1,1,1,1,
	                        0,1,1,1,0,
	                        0,0,1,0,0,
	                        0,0,0,0,0,
	                        0,0,0,0,0},
	                       {0,0,0,0,1,
	                        0,0,0,1,1,
	                        0,0,1,1,1,
	                        0,0,0,1,1,
	                        0,0,0,0,1},
	                       {0,0,0,0,0,
	                        0,0,0,0,0,
	                        0,0,1,0,0,
	                        0,1,1,1,0,
	                        1,1,1,1,1},
	                      
	                       {1,1,1,0,0,
	                        1,1,1,0,0,
	                        1,1,1,0,0,
	                        0,0,0,0,0,
	                        0,0,0,0,0},
	                       {0,0,1,1,1,
	                        0,0,1,1,1,
	                        0,0,1,1,1,
	                        0,0,0,0,0,
	                        0,0,0,0,0},
	                       {0,0,0,0,0,
	                        0,0,0,0,0,
	                        0,0,1,1,1,
	                        0,0,1,1,1,
	                        0,0,1,1,1},
	                       {0,0,0,0,0,
	                        0,0,0,0,0,
	                        1,1,1,0,0,
	                        1,1,1,0,0,
	                        1,1,1,0,0},
	                      
	                       {0,0,0,0,0,
	                        0,1,1,1,0,
	                        0,1,1,1,0,
	                        0,1,1,1,0,
	                        0,0,0,0,0}};

	unsigned char* pix;
	unsigned int   canal;
	unsigned int   x,y;
	int    ny,nx,m;
	unsigned int   min,ind;

	for( canal = 0; canal < _image.GetChanNumber(); ++canal )
	{
		for( y = n; y < _image.GetHeight()-n; ++y )
		{
			for( x = n; x < _image.GetWidth()-n; ++x )
			{
				for( m = 0; m < 9; ++m )
				{
					moyenne[m] = 0;
					for( ny = -n; ny <= n; ++ny )
					{
						for( nx = -n; nx <= n; ++nx )
						{
							pix = _image.GetPixel( x+nx, y+ny );
							moyenne[m] += pix[canal] * masques[m][(2*n+1)*(ny+n)+(nx+n)];
						}
					}
					moyenne[m] /= 9;

					variance[m] = 0;
					for( ny = -n; ny <= n; ++ny )
					{
						for( nx = -n; nx <= n; ++nx )
						{
							pix = _image.GetPixel( x+nx, y+ny );
							variance[m] += (pix[canal] - moyenne[m])*(pix[canal] - moyenne[m]) * masques[m][(2*n+1)*(ny+n)+(nx+n)];
						}
					}
					variance[m] /= 9;
				}

				min = variance[0];
				ind = 0;
				for( m = 1; m < 9; ++m )
				{
					if( variance[m] < min )
					{
						min = variance[m];
						ind = m;
					}
				}

				pix =  image_retour.GetPixel( x, y );
				pix[canal] = moyenne[ind];
			}
		}
	}
	
	return image_retour;
}

}
