#pragma once

#include <ImageLib.h>
#include <complex>

typedef std::complex<double> Complex;

class Fourier
{
public:
	Fourier( const Image& image );
	~Fourier();

	void Transform();
	Image TransformInverse( void );

	void FastTransform();
	Image FastTransformInverse( void );

	Image GetResult();

	void IdealFilter( unsigned int radius );
	void GaussianFilter( double sigma );

	void Save(); //Pour l'interface
	void Load(); //Pour l'interface


private:
	Complex** m_X, *m_Exp, **m_XTemp;
	Complex** m_XSave;
	unsigned int m_C;
	unsigned int m_L;
	Image m_image;

	static void InverseBits( unsigned int* value, unsigned int nb_bits );
	void Center();
	void Reorganisation();
	void ComputeExp();
	void Butterfly( const unsigned int l, const unsigned int c, const unsigned int size, const int sign );
	
};
