#include "gradient_utils.h"




// Constructeurs
Gradient::Gradient( void ) : m_gradients(NULL), m_module(NULL), m_orientation(NULL)
{
	Clear();
}
Gradient::Gradient( const Image* image, GradientMaskType type ) : m_gradients(NULL), m_module(NULL), m_orientation(NULL)
{
	ComputeFromImage( image, type );
}


// Destructeur
Gradient::~Gradient( void )
{
	Clear();
}


// Retourne un pointeur vers l'image rsultante du gradient
Image* Gradient::GetResult( void )
{
	return &m_result;
}




// Nettoyage de la mmoire
void Gradient::Clear( void )
{
	if( m_gradients )
	{
		for( uint i = 0; i < mask_orientation_number; i++ )
		{
			delete [] m_gradients[i];
		}
		delete m_gradients;

		m_gradients = NULL;
	}

	if( m_module )
	{
		delete [] m_module;

		m_module = NULL;
	}

	if( m_orientation )
	{
		delete [] m_orientation;

		m_orientation = NULL;
	}
}
