#pragma once


#include <ImageLib.h>
#include "utils.h"


class Gradient
{
public:

	enum GradientMaskType
	{
		mask_type_sobel = 0,
		mask_type_kirsch,
		mask_type_prewitt,
		mask_type_prewitt2,

		mask_type_mask_number
	};


	Gradient( void );
	Gradient( const Image*, GradientMaskType );

	~Gradient( void );

	Image* GetResult( void );


	void ComputeFromImage( const Image*, GradientMaskType );

	void ThresholdGlobal    ( uchar value );
	void ThresholdLocal     ( int window_size );
	void ThresholdHysteresis( uchar low, uchar high );

	void Refine( void );

	void Link( void );


protected:

	void ComputeModule     ( void );
	void ComputeOrientation( void );

	void Clear( void );




	float** m_gradients;
	float*  m_module;


	enum GradientOrientation
	{
		orientation_unknown,

		orientation_east,
		orientation_northeast,
		orientation_north,
		orientation_northwest,

		orientation_number
	};

	GradientOrientation* m_orientation;

	Image m_result;
};
