#include "gradient_utils.h"




// Affinage
void Gradient::Refine( void )
{
	const uint width  = m_result.GetWidth();
	const uint height = m_result.GetHeight();

	_DEBUG_SHOW_TIMES_START;

	for( uint y = MASK_N; y < height-MASK_N; y++ )
	{
		for( uint x = MASK_N; x < width-MASK_N; x++ )
		{
			const uint index   = x + (width*y);
			const float module = m_module[ index ];
			uchar* const pixel = m_result.GetPixel( index );

			if( pixel[0] > 0 )
			{
				uint index_neighbor1 = index;
				uint index_neighbor2 = index;

				// On est sur un contour
				switch( m_orientation[ index ] )
				{
				case orientation_north:
					index_neighbor1 -= width;
					index_neighbor2 += width;
					break;
				case orientation_northeast:
					index_neighbor1 -= width - 1;
					index_neighbor2 += width - 1;
					break;
				case orientation_east:
					index_neighbor1 -= 1;
					index_neighbor2 += 1;
					break;
				case orientation_northwest:
					index_neighbor1 -= width + 1;
					index_neighbor2 += width + 1;
					break;
				default:
					break;
				}

				const float neighbor1 = m_module[ index_neighbor1 ];
				const float neighbor2 = m_module[ index_neighbor2 ];

				if( module >= neighbor1 && module > neighbor2 )
				{
					// On est sur un maximum local
					pixel[0] = 255;
				}
				else
				{
					pixel[0] = 0;
				}
			}
		}
	}

	_DEBUG_SHOW_TIMES_STOP( "affinage des contours" );

#ifdef _DEBUG_SAVE_REFINED
	m_result.SavePNG( _DEBUG_SAVE_PREFIX "affinage.png" );
#endif
}
