#pragma once


#include "gradient.h"


#include <ctime>
#include <cmath>
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include "utils.h"
#include "masks.h"


// Parametres
/*#define _DEBUG_SHOW_TIMES
#define _DEBUG_SHOW_TIMES_PREFIX " - temps: "

#define _DEBUG_SAVE_GRADIENTS
#define _DEBUG_SAVE_MODULE
#define _DEBUG_SAVE_ORIENTATION
#define _DEBUG_SAVE_THRESHOLD
#define _DEBUG_SAVE_REFINED
#define _DEBUG_SAVE_LINKS
#define _DEBUG_SAVE_PREFIX       "resultat_"*/
// ---


// Benchmarking
#ifdef  _DEBUG_SHOW_TIMES
static clock_t _debug_clock_start;
static clock_t _debug_clock_stop;

#define _DEBUG_SHOW_TIMES_START       do{ \
                                          _debug_clock_start = clock(); \
                                      } while( false )
#define _DEBUG_SHOW_TIMES_STOP( msg ) do{ _debug_clock_stop  = clock(); \
                                          printf( _DEBUG_SHOW_TIMES_PREFIX msg " ... %.3f secondes\n", static_cast< double >(_debug_clock_stop - _debug_clock_start) / CLOCKS_PER_SEC ); \
                                         _debug_clock_start = _debug_clock_stop; \
                                      }while( false )
#else
#define _DEBUG_SHOW_TIMES_START       {}
#define _DEBUG_SHOW_TIMES_STOP( msg ) {}
#endif
// ---




// Fonctions locales
const GradientMask* GetMasks( Gradient::GradientMaskType );

void SaveToImage( const char* filename, float* data, uint width, uint height );
