#pragma once


#define MASK_N    1
#define MASK_SIZE ((MASK_N*2) + 1)


// Masques
enum GradientMaskOrientation
{
	mask_orientation_east      = 0,
	mask_orientation_northeast = 1,
	mask_orientation_north     = 2,
	mask_orientation_northwest = 3,

	mask_orientation_number
};

typedef const int GradientMask[ mask_orientation_number ][ MASK_SIZE ][ MASK_SIZE ];




static GradientMask g_mask_sobel =
{
	{ {-1, 1, 1} , {-1,-2, 1} , {-1, 1, 1} } , // E
	{ { 1, 1, 1} , {-1,-2 ,1} , {-1,-1, 1} } , // NE
	{ { 1, 1, 1} , { 1,-2, 1} , {-1,-1,-1} } , // N
	{ { 1, 1, 1} , { 1,-2,-1} , { 1,-1,-1} }   // NW
};

static GradientMask g_mask_kirsch  =
{
	{ {-3,-3, 5} , {-3, 0, 5} , {-3,-3, 5} }, // E
	{ {-3, 5, 5} , {-3, 0, 5} , {-3,-3,-3} }, // NE
	{ { 5, 5, 5} , {-3, 0,-3} , {-3,-3,-3} }, // N
	{ { 5, 5,-3} , { 5, 0,-3} , {-3,-3,-3} }  // NW
};

static GradientMask g_mask_prewitt =
{
	{ {-1, 0, 1} , {-2, 0, 2} , {-1, 0, 1} }, // E
	{ { 0, 1, 2} , {-1, 0, 1} , {-2,-1, 0} }, // NE
	{ { 1, 2, 1} , { 0, 0, 0} , {-1,-2,-1} }, // N
	{ { 2, 1, 0} , { 1, 0,-1} , { 0,-1,-2} }  // NW
};

static GradientMask g_mask_prewitt2 =
{
	{ {-1, 0, 1} , {-1, 0, 1} , {-1, 0, 1} }, // E
	{ { 0, 1, 1} , {-1, 0, 1} , {-1,-1, 0} }, // NE
	{ { 1, 1, 1} , { 0, 0, 0} , {-1,-1,-1} }, // N
	{ { 1, 1, 0} , { 1, 0,-1} , { 0,-1,-1} }  // NW
};
