#pragma once


typedef unsigned int  uint;
typedef unsigned char uchar;


// Fonction de Clampage
// R type de retour
// T type des donnes
//
// exemple: int r = Clamp< int, double >( 50.0, 0, 100 );
template< typename R, typename T >
R Clamp( T x, R min, R max )
{
	if( static_cast< R >( x ) < min )
	{
		return min;
	}
	else if( static_cast< R >( x ) > max )
	{
		return max;
	}
	else
	{
		return static_cast< R >( x );
	}
}


// Valeur absolue
template< typename T >
T Abs( T x )
{
	if( x < 0 )
	{
		return -x;
	}
	else
	{
		return x;
	}
}


// Minimums et Maximums
template< typename T >
T Min( T x, T y )
{
	if( x <= y )
	{
		return x;
	}
	else
	{
		return y;
	}
}

template< typename T >
T Max( T x, T y )
{
	if( x >= y )
	{
		return x;
	}
	else
	{
		return y;
	}
}




#include <ImageLib.h>

// Converti une image en niveraux de gris
void ConvertToGrayscale( Image* );

// Cree l'histogramme d'une image
void ComputeHistogram( Image* histogram, const Image* source );

// Seuil une image
//void ThresholdGlobal( Image* image, uchar threshold, bool binarise );
//void ThresholdLocal ( Image* image, int size, bool binarise );
//void ThresholdHysteresis( Image* image, uchar threshold_low, uchar threshold_high, bool binarise );

// Dessine une ligne dans une image en niveaux de gris
void DrawLine( Image* image, int x0, int y0, int x1, int y1, uchar gray_value );
