#pragma once


typedef unsigned int  uint;
typedef unsigned char uchar;


#include <cmath>
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif


// Fonction de Clampage
// R type de retour
// T type des donnes
//
// exemple: int r = Clamp< int, double >( 50.0, 0, 100 );
template< typename R, typename T >
R Clamp( const T x, const R min, const R max )
{
	if( static_cast< R >( x ) < min )
	{
		return min;
	}
	else if( static_cast< R >( x ) > max )
	{
		return max;
	}
	else
	{
		return static_cast< R >( x );
	}
}


// Valeur absolue
template< typename T >
T Abs( const T x )
{
	if( x < 0 )
	{
		return -x;
	}
	else
	{
		return x;
	}
}


// Minimums et Maximums
template< typename T >
T Min( const T x, const T y )
{
	if( x <= y )
	{
		return x;
	}
	else
	{
		return y;
	}
}

template< typename T >
T Max( const T x, const T y )
{
	if( x >= y )
	{
		return x;
	}
	else
	{
		return y;
	}
}




#include <ImageLib.h>


void SaveToImage( Image*, int* data, int width, int height );

void PrepareDestination( Image*, const Image* );
