#pragma once

#include <ImageLib.h>

#include <vector>
using std::vector;
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

class Histo
{
private:
	vector< unsigned int > m_tab;
	unsigned int m_size;
	unsigned int m_pixel_number;
	unsigned int m_max;

public:
	Histo( unsigned int _size = 256 );
	Histo( const Histo& );
	Histo( const Image&, unsigned int _size = 256 );
	~Histo();
	
	const unsigned int size()			const { return m_size; }
	const unsigned int pixelNumber()	const { return m_pixel_number; }
	const unsigned int max()			const { return m_max; }
	void setSize( unsigned int _size )					{ m_size = _size; }
	void setPixelNumber( unsigned int _pixel_number )	{ m_pixel_number = _pixel_number; }
	void setMax( unsigned int _max )					{ m_max = _max; }

	bool load( const char *_filename );
	bool save( const char *_filename ) const;

	Image toImage( unsigned int _height = 256 ) const;
	
	
	void computeFromImage( const Image& _image, unsigned int _channel = 0 );
	Histo cumulated();
	void clear();
	
	void addPixel( const unsigned int _index );
	bool removePixel( const unsigned int _index );
	
	unsigned int & operator[]( const unsigned int _index );
	const unsigned int operator[]( const unsigned int _index ) const;
	
	const Histo& operator=( const Histo& _histo );
};
